/*
    countCharSize.cc
  
    Copyright (C) 1998, 1999 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */

#include <cassert>

#include "util/mytype.h"
#include "util/KanjiConvert.h"

using namespace std;

int countCharSize (const char* eucString, int numOfBytes)
{
  int now = 0;//$B8=:_:]$7$F$$$k>l=j!#(B
  int count = 0;//$B2?(Bchar$BM-$k$+?t$($k!#(B
  while (now < numOfBytes)
    {
      if (isiso (eucString[now]))
	{//iso
	  now++;
	  count++;
	}
      else if (iskanji (eucString[now]))
	{//$BA43Q4A;z(B
	  assert (now < numOfBytes);
	  assert (0x80 & eucString[now+1]);
	  now += 2;
	  count += 2;
	}
      else if (iskana (eucString[now]))
	{//$BH>3Q$+$J(B
	  assert (now < numOfBytes);
	  assert (0x80 & eucString[now+1]);
	  now += 2;
	  count++;
	}
      else
	{
	  DEBUG_MESSAGE ("countCharSize: error?");
	}
    }

  return count;
}
