/*
    SherryPalatte.h
  
    Copyright (C) 1998, 1999 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef SherryPalette_H
#define SherryPalette_H

#include <cassert>

#include "SherryPaletteEntry.h"

using namespace std;

class SherryPalette
{
public:
  static const int MAX_PALETTES = 256;

private:
  SherryPaletteEntry entry[MAX_PALETTES];

public:
  SherryPalette () {};
  ~SherryPalette () {};

  void set (int i, uint8 r, uint8 g, uint8 b) {entry[i].set (r, g, b);};
  void copy (const SherryPalette* source)
    {
      assert (source != NULL);
      for (int i = 0; i < MAX_PALETTES; i++)
	entry[i].copy (source->getEntry (i));
    };
  void copyEntry (int i, const SherryPaletteEntry& sourceEntry)
    {
      entry[i].copy (sourceEntry);
    };
  const SherryPaletteEntry& getEntry (int i) const {return entry[i];};
  void reset ()
    {
      for (int i = 0; i < MAX_PALETTES; ++i)
	entry[i].reset ();
    };
};

#endif // SherryPalette_H
