/*
    GTKBase.h
  
    Copyright (C) 1998, 1999 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef GTKBase_H
#define GTKBase_H

#include "util/Mutex.h"
#include "PlugIn/X/XBase/XBase.h"

//mixin for GTK
class GTKBase:public XBase
{
private:
  static Mutex gtkLock;
  //XXX gtk_init$B$N0z?t$KM?$($k$b$N!#0lBN2?$r;XDj$7$?$iNI$$$b$N$d$i!#(B
  static int gtkArgc;
  static char** gtkArgv;
  
  static int nrChild;
  static pthread_once_t gtkInit;
  static void initGTK ();
  static void* gtkMain (void*);
  static pthread_t gtkMainThread;
public:
  GTKBase ();
  ~GTKBase ();
};
#endif // GTKBase_H
