/*
    GtkCallBackTemplage.h
  
    Copyright (C) 1998, 1999 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef GtkCallBackTemplate_H
#define  GtkCallBackTemplate_H


#define COMMA ,
//e.g.
//gtk_signal_connect (GTK_OBJECT (widget), "clicked",
//                    GTK_SIGNAL_FUNC (&gtkCallBack<MyClass COMMA &MyClass::callBackMethod>),
//		      static_cast<GtkObject*> (static_cast<gpointer> (this)));
//use COMMA because of `,' is interpreted by cpp

template<typename T, void (T::*realCallBackMethod) ()>
void gtkCallBack (GtkWidget*, gpointer me)
{
  (static_cast<T*> (me)->*realCallBackMethod) ();
};

//e.g.
//gtk_signal_connect_object (GTK_OBJECT (widget), "clicked",
//                           GTK_SIGNAL_FUNC (&gtkCallBack<MyClass COMMA &MyClass::callBackMethod>),
//		             static_cast<GtkObject*> static_cast<gpointer> ((this)));
template<typename T, void (T::*realCallBackMethod) ()>
void gtkObjectCallBack (gpointer me)
{
  (static_cast<T*> (me)->*realCallBackMethod) ();
};

#endif // GtkCallBackTemplate_H
