/*
    WtkLockedRange.cc
  
    Copyright (C) 1998, 1999 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "WtkLockedRange.h"

WtkLockedRange::WtkLockedRange (Display* display,
				const char* className_, const char* name_, 
				int x_, int y_, uint width_, uint height_,
				int depth, Visual* visual, Colormap colormap_,
				char* resourceFileName):
  WtkRange (display, className_, name_, x_, y_, width_, height_,
	    depth, visual, colormap_, resourceFileName)
{
  //do nothing
}

WtkLockedRange::WtkLockedRange (Display* display,
				const char* className_, const char* name_,
				int x_, int y_, uint width_, uint height_,
				int depth, Visual* visual, Colormap colormap_,
				XrmDatabase displayRdb_):
  WtkRange (display, className_, name_, x_, y_, width_, height_,
	    depth, visual, colormap_, displayRdb_)
{
  //do nothing
}


WtkLockedRange::WtkLockedRange (WtkWidget* parent,
				const char* className_, const char* name_,
				int x_, int y_, uint width_, uint height_):
  WtkRange (parent, className_, name_, x_, y_, width_, height_)
{
  //do nothing
}

WtkLockedRange::~WtkLockedRange ()
{
  //do nothing
}


void WtkLockedRange::widgetButtonReleased (XEvent* event)
{
  if (isSliderDragged)
    scrolled (limit, calcPosition (event), scope);
  isSliderDragged = false;
}

void WtkLockedRange::widgetPointerMotion (XEvent* event)
{
  if (isSliderDragged)
    unlockedSetPosition (calcPosition (event), false);
}


