/*
    createFontSet.cc
  
    Copyright (C) 1998, 1999 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <iostream>

#include "createFontSet.h"

using namespace std;

XFontSet createFontSet (Display* display, const char* fontName)
{
  char** mclr = NULL;
  int mccr = 0;
  char* dsr = NULL;
  XFontSet fontSet = XCreateFontSet (display, fontName, &mclr, &mccr, &dsr);
  if (mclr != NULL || mccr != 0)
    {
#ifdef DEBUG
      cerr << "createFontSet "
	   << "XCreateFontSet returns missing char set list." << endl;
      cerr << "fontName = " << fontName << endl;
      if (mclr != NULL)
	{
	  cerr << "mclr != NULL:";
	  for (int i = 0; i < mccr; i++)
	    cerr << mclr[i] << endl;
	}
      cerr << "mccr = " << mccr << endl;
      if (dsr != NULL)
	cerr << "dsr != NULL:dsr = " << dsr << endl;
#endif
      if (mclr != NULL)
	XFreeStringList (mclr);
      //XXX$B$b$C$H$^$7$J%(%i!<=hM}$,$"$kH&!#(B
      //throw IError ("IOXWrd::setupResource can not load fontset.");
      exit (1);
    }

  return fontSet;
}
