/*
    SongFileItem.h
  
    Copyright (C) 1998, 1999 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef SongFileItem_H
#define SongFileItem_H

#include <functional>

#include "Song/Song.h"

using namespace std;

class SongFileItem
{
private:
  string fileName;
  bool isPlayTimeSet__;
  uint32 playTime;
  bool isTitleSet__;
  string title;
  
public:
  SongFileItem (const Song* song):
    fileName (song->getFileName ()),
    isPlayTimeSet__ (true), playTime (song->getPlayTime ()),
    isTitleSet__ (true), title (song->getTitle ())
    {/*do nothing*/};
  SongFileItem (const string& fileName__):
    fileName (fileName__),
    isPlayTimeSet__ (false), playTime (0),
    isTitleSet__ (false),title ()
    {/*do nothing*/};
  ~SongFileItem () {};

  const string& getFileName () const {return fileName;};
  bool isPlayTimeSet () const {return isPlayTimeSet__;};
  uint32 getPlayTime () const {return playTime;};
  bool isTitleSet () const {return isTitleSet__;};
  const string& getTitle () const {return title;};

  void setPlayTime (uint32 playTime__);
  void setTitle (const string& title__);
  void set (const Song* song);
  
  //file̾åȤƤʤfileõƱջ֤ȥ롣
  //֤ͤõݤ
  //Ԥ븶ȤƤfile̵ä,ղǽեǤʤä
  bool search ();

  bool operator == (const SongFileItem& rhs) const
    {
      return
      (getFileName ()   == rhs.getFileName ()) &&
      (isPlayTimeSet () == rhs.isPlayTimeSet ()) &&
      (isTitleSet ()    == rhs.isTitleSet ()) &&
      (getPlayTime ()   == rhs.getPlayTime ()) &&
      (getTitle ()      == rhs.getTitle ());
    };

#if 0
  SongFileTime& operator = (const SongFileItem& rhs)
    {
      if (this != &rhs)
      {
	fileName = rhs.fileName;
	isPlayTimeSet__ = rhs.isPlayTimeSet__;
	playTime = rhs.play1Time;
	isTitleSet__ = rhs.isTitleSet__;
	title = rhs.tittle;
      }
      return *this;
    };
#endif
  
  ///////////////////////////////////////////////////////////////for sorting
  class FileNameLess
  {
  public:
    bool operator () (const SongFileItem& first, const SongFileItem& second)
      {
	return less<string>() (first.getFileName (), second.getFileName ());
      };
  };
  class FileNameGreater
  {
  public:
    bool operator () (const SongFileItem& first, const SongFileItem& second)
      {
	return greater<string>() (first.getFileName (), second.getFileName ());
      };
  };

  class PlayTimeLess
  {
  public:
    bool operator () (const SongFileItem& first, const SongFileItem& second)
      {
	return less<uint32>() (first.getPlayTime (), second.getPlayTime ());
      };
  };
  class PlayTimeGreater
  {
  public:
    bool operator () (const SongFileItem& first, const SongFileItem& second)
      {
	return greater<uint32>() (first.getPlayTime (), second.getPlayTime ());
      };
  };

  class TitleLess
  {
  public:
    bool operator () (const SongFileItem& first, const SongFileItem& second)
      {
	return less<string>() (first.getTitle (), second.getTitle ());
      };
  };
  class TitleGreater
  {
  public:
    bool operator () (const SongFileItem& first, const SongFileItem& second)
      {
	return greater<string>() (first.getTitle (), second.getTitle ());
      };
  };

  class Equal
  {
  public:
    bool operator () (const SongFileItem& first, const SongFileItem& second)
      {
	return (first.getFileName () == second.getFileName ());
      };
  };
  
};
#endif // SongFileItem_H
