/*
    TimerConnection.h
  
    Copyright (C) 1998, 1999 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef TimerConnection_H
#define TimerConnection_H

class TimerConnection
{
protected:
  TimerConnection (){/*do nothing*/};
  
public:
  virtual void call () = 0;
};

template <typename T>
class TimerConnectionImple:public TimerConnection
{
private:
  T* const obj;
  void (T::*const method) (void* arg);
  void* const arg;
  
public:
  TimerConnectionImple (T* obj__, void (T::*method__) (void*), void* arg__):
    obj (obj__), method (method__), arg (arg__) {/*do nothing*/};
  
  virtual void call ()
    {(obj->*method) (arg);};
};
#endif// TimerConnection_H
