/*
    TimerSignal.h
  
    Copyright (C) 1998, 1999 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef TimerSignal_H
#define TimerSignal_H

#include <list>

#include "util/mytype.h"
#include "TimerConnection.h"

using namespace std;

class TimerSignal
{
public:
  typedef uint Tag;
  
private:
  typedef list<pair<Tag, TimerConnection*> > Connections;
  Connections connections;
  
public:
  TimerSignal () {};
  ~TimerSignal ();

  void connect (Tag tag, TimerConnection* timerConnection__);

  template <typename T>
  void connect (Tag tag, T* t,
		void (T::*method) (void*), void* arg)
    {
      return connect (tag, new TimerConnectionImple<T> (t, method, arg));
    };
  
  bool disconnect (Tag tag);
  Connections::size_type size ()
    {
      return connections.size ();
    };

  //tags뤿access method
  Connections::iterator getBegin () {return connections.begin ();};
  Connections::iterator getEnd () {return connections.end ();};
  
  void operator ()();
};
#endif //TimerSignal_H
