/*
    PThreadStartRoutine.h
  
    Copyright (C) 1998, 1999 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef PThreadStartRoutine_H
#define PThreadStartRoutine_H

#include <cassert>

#include "util/mytype.h"

using namespace std;

//this is not appropriate, because of that template function can not have
//"C" linkage.
//but under egcs, this seems to work.
template<class T, void (T::*startRoutine) ()>
void* PThreadStartRoutine (void* me)
{
  DEBUG_MESSAGE ("PThreadStartRoutine called");
  assert (me != NULL);
  assert (startRoutine != NULL);
  DEBUG_MESSAGE ("PThreadStartRoutine calling method");
  (static_cast<T*>(me)->*startRoutine) ();
  return NULL;
};

#endif // PThreadStartRoutine_H
